-- Custom Behavior Helpers --

-- Copied from the Star Road Port (thx to who made the function)
--- Replacement for DROP_TO_FLOOR()
function object_drop_to_floor(obj)
    local x = obj.oPosX
    local y = obj.oPosY
    local z = obj.oPosZ

    local floorHeight = find_floor_height(x, y + 200, z)
    obj.oPosY = floorHeight
    obj.oMoveFlags = (obj.oMoveFlags | OBJ_MOVE_ON_GROUND)
end

-- Custom Behaviors --

local function penguin_npc_init(o)
    o.oFlags = OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_HOLDABLE | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oAnimations = gObjectAnimations.penguin_seg5_anims_05008B74
    o.oInteractType = INTERACT_TEXT
    object_drop_to_floor(o)
    obj_set_hitbox_radius_and_height(o, 100, 60)
    obj_init_animation(o, 0)
    o.oBobombBuddyRole = 0
    cur_obj_set_home_once()
    bhv_bobomb_buddy_init()
    o.oIntangibleTimer = 0
end

local function penguin_npc_loop(o)
    bhv_bobomb_buddy_loop() -- Generates script errors if used as the loop function for some reason
end

hook_behavior(id_bhvBobombBuddy, OBJ_LIST_GENACTOR, true, penguin_npc_init, penguin_npc_loop)

